#include <stdio.h>

int main(void) {
    // Variables para ejemplos
    int a = 10, b = 5, resultado;
    float x = 5.5, y = 2.5;

    // --- Operadores aritméticos ---
    printf("--- Operadores Aritméticos ---\n");
    printf("Suma: %d + %d = %d\n", a, b, a + b);         // Suma
    printf("Resta: %d - %d = %d\n", a, b, a - b);       // Resta
    printf("Multiplicación: %d * %d = %d\n", a, b, a * b); // Multiplicación
    printf("División: %d / %d = %d\n", a, b, a / b);    // División (entera)
    printf("Módulo: %d %% %d = %d\n", a, b, a % b);     // Módulo (residuo)

    // --- Operadores unarios ---
    printf("\n--- Operadores Unarios ---\n");
    printf("Negativo: -a = %d\n", -a);                  // Negativo
    printf("Incremento: ++a = %d\n", ++a);              // Pre-incremento
    printf("Decremento: --b = %d\n", --b);              // Pre-decremento

    // --- Operadores de asignación ---
    printf("\n--- Operadores de Asignación ---\n");
    resultado = a;                                      // Asignación simple
    printf("Asignación: resultado = %d\n", resultado);
    resultado += b;                                     // Asignación con suma
    printf("Suma asignación: resultado += b -> %d\n", resultado);
    resultado *= b;                                     // Asignación con multiplicación
    printf("Multiplicación asignación: resultado *= b -> %d\n", resultado);

    // --- Operadores de comparación ---
    printf("\n--- Operadores de Comparación ---\n");
    printf("%d == %d -> %d\n", a, b, a == b);           // Igualdad
    printf("%d != %d -> %d\n", a, b, a != b);           // Desigualdad
    printf("%d > %d -> %d\n", a, b, a > b);             // Mayor que
    printf("%d < %d -> %d\n", a, b, a < b);             // Menor que
    printf("%d >= %d -> %d\n", a, b, a >= b);           // Mayor o igual
    printf("%d <= %d -> %d\n", a, b, a <= b);           // Menor o igual

    // --- Operadores lógicos ---
    printf("\n--- Operadores Lógicos ---\n");
    printf("a > b && b < 20 -> %d\n", (a > b) && (b < 20)); // AND lógico
    printf("a < b || b > 0 -> %d\n", (a < b) || (b > 0));   // OR lógico
    printf("!(a == b) -> %d\n", !(a == b));                 // NOT lógico

    // --- Operadores de bits ---
    printf("\n--- Operadores de Bits ---\n");
    printf("AND: %d & %d = %d\n", a, b, a & b);             // AND a nivel de bits
    printf("OR: %d | %d = %d\n", a, b, a | b);              // OR a nivel de bits
    printf("XOR: %d ^ %d = %d\n", a, b, a ^ b);             // XOR a nivel de bits
    printf("Desplazamiento a la izquierda: %d << 1 = %d\n", a, a << 1); // Desplazamiento a la izquierda
    printf("Desplazamiento a la derecha: %d >> 1 = %d\n", a, a >> 1);   // Desplazamiento a la derecha

    return 0;
}
